#include <string.h>
#include <stdint.h>
#include <stdio.h>
#include <stddef.h>
#include <sys/time.h>
#include <stdlib.h>

#include "e_lib.h"

typedef uint32_t BF_word;
typedef int32_t BF_word_signed;
typedef BF_word BF_binary[6];
typedef struct
{
	BF_binary out[16] __attribute__ ((packed));
	int test[16] __attribute__ ((packed));
	int start[16] __attribute__ ((packed));
	int core_done[16] __attribute__ ((packed));
	char key[16][72+1] __attribute__ ((packed));
	char hash[16][61] __attribute__ ((packed));
	int done __attribute__ ((packed));
} data;	

volatile data outbuf SECTION("shared_dram");

int main(void)
{	
	int coreID, row, col, corenum, i;
	
	coreID  = e_get_coreid();
	e_coords_from_coreid(coreID, &row, &col);
	row = row - E_FIRST_CORE_ROW;
	col = col - E_FIRST_CORE_COL;
	corenum = row * E_COLS_IN_CHIP + col;
	
	while(outbuf.start[corenum] == 0);

	outbuf.core_done[corenum] = 10;

	return EXIT_SUCCESS;
}
